window.Gleam.initSearch([{"doc":"lustre_http","title":"lustre_http","content":"# lustre_http\n\n[![Package Version](https://img.shields.io/hexpm/v/lustre_http)](https://hex.pm/packages/lustre_http)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/lustre_http/)\n\nMake HTTP requests from `lustre` via its `cmd` interface.\nMakes life easy when such requests are initiated by the user.\n\n## Quick start\n\nAdd to your Gleam project:\n\n```sh\ngleam add lustre_http\n```\n\nView the documentation at &lt;https://hexdocs.pm/lustre_http&gt;, although only `get_as_text` is documented a.t.m.\n","url":"index.html"},{"doc":"lustre_http","title":"HttpError","content":"pub type HttpError {\n  Unauthorized\n  NotFound\n  InternalServerError(String)\n  OtherError(Int, String)\n}\n\nUnauthorized\n\n\nNotFound\n\n\nInternalServerError(String)\n\n\nOtherError(Int, String)\n\n\nSynonyms:\nlustre_http.HttpError\nlustre_http HttpError","url":"lustre_http.html#HttpError"},{"doc":"lustre_http","title":"HttpOrJsonError","content":"pub type HttpOrJsonError {\n  H(HttpError)\n  J(json.DecodeError)\n}\n\nH(HttpError)\n\n\nJ(json.DecodeError)\n\n\nSynonyms:\nlustre_http.HttpOrJsonError\nlustre_http HttpOrJsonError","url":"lustre_http.html#HttpOrJsonError"},{"doc":"lustre_http","title":"JsonResult","content":"pub type JsonResult(t) =\n  Result(t, HttpOrJsonError)\n\n\nSynonyms:\nlustre_http.JsonResult\nlustre_http JsonResult","url":"lustre_http.html#JsonResult"},{"doc":"lustre_http","title":"StringResult","content":"pub type StringResult =\n  Result(String, HttpError)\n\n\nSynonyms:\nlustre_http.StringResult\nlustre_http StringResult","url":"lustre_http.html#StringResult"},{"doc":"lustre_http","title":"get_as_json","content":"pub fn get_as_json(url: String, to_msg: fn(\n    Result(String, HttpOrJsonError),\n  ) -&gt; a, decoder: fn(Dynamic) -&gt;\n    Result(String, List(DecodeError))) -&gt; Effect(a)\n Will automatically try to decode the JSON for you.\n The error-type is a bit complicated. In a future version will probably\n (a) force &quot;text/json&quot; in the headers (b) not decode for you.\nSynonyms:\nlustre_http.get_as_json\nlustre_http get_as_json","url":"lustre_http.html#get_as_json"},{"doc":"lustre_http","title":"get_as_text","content":"pub fn get_as_text(url: String, to_msg: fn(\n    Result(String, HttpError),\n  ) -&gt; a) -&gt; Effect(a)\n ###  Usage\n \n import lustre_http as http\n\n type Msg {\n   SomeInteraction\n   TextReceived(StringResult)\n }\n\n pub fn update(model, msg) {\n   case msg {\n     SomeInteraction -&gt; #(model, http.get_as_text(&quot;the_text&quot;, TextReceived))\n     TextReceived(Ok(text)) -&gt; #(apply(text, model), effect.none())\n     TextReceived(Error(e)) -&gt; #(indicate_problem(e, model), effect.none())\n   }\n }\n \nSynonyms:\nlustre_http.get_as_text\nlustre_http get_as_text","url":"lustre_http.html#get_as_text"},{"doc":"lustre_http","title":"post_text","content":"pub fn post_text(url: String, body: String, to_msg: fn(\n    Result(String, HttpError),\n  ) -&gt; a) -&gt; Effect(a)\n Future versions will force headers in both the request and the response\n so you can post json and receive text, post text and receive json, etc.\nSynonyms:\nlustre_http.post_text\nlustre_http post_text","url":"lustre_http.html#post_text"},{"doc":"lustre_http","title":"lustre_http","content":"","url":"lustre_http.html"}]);